// Generated by psc version 0.8.2.0
"use strict";
var $foreign = require("./foreign");
var Prelude = require("../Prelude");
var Data_Argonaut_Printer = require("../Data.Argonaut.Printer");
var Data_Argonaut_Parser = require("../Data.Argonaut.Parser");
var Data_Argonaut_Decode = require("../Data.Argonaut.Decode");
var Data_Argonaut_Encode = require("../Data.Argonaut.Encode");
var Data_Array = require("../Data.Array");
var Data_Array_Unsafe = require("../Data.Array.Unsafe");
var Data_Date = require("../Data.Date");
var Data_Either = require("../Data.Either");
var Data_Foldable = require("../Data.Foldable");
var Data_Traversable = require("../Data.Traversable");
var Data_StrMap = require("../Data.StrMap");
var Data_StrMap_ST = require("../Data.StrMap.ST");
var Data_Maybe = require("../Data.Maybe");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console_1 = require("../Control.Monad.Eff.Console");
var Control_Monad_Eff_Console_1 = require("../Control.Monad.Eff.Console");
var Control_Monad_Eff_Exception = require("../Control.Monad.Eff.Exception");
var Control_Monad_ST_1 = require("../Control.Monad.ST");
var Control_Monad_ST_1 = require("../Control.Monad.ST");
var Control_Apply = require("../Control.Apply");
var Control_Monad = require("../Control.Monad");
var Node_Platform = require("../Node.Platform");
var Node_Process_1 = require("../Node.Process");
var Node_Process_1 = require("../Node.Process");
var Node_ChildProcess_1 = require("../Node.ChildProcess");
var Node_ChildProcess_1 = require("../Node.ChildProcess");
var Node_Stream = require("../Node.Stream");
var Node_Buffer = require("../Node.Buffer");
var Node_Encoding = require("../Node.Encoding");
var Node_FS = require("../Node.FS");
var Node_FS_Sync = require("../Node.FS.Sync");
var Node_FS_Stats = require("../Node.FS.Stats");
var Node_Path = require("../Node.Path");
var Unsafe_Coerce = require("../Unsafe.Coerce");
var Psa = require("../Psa");
var Psa_Printer_Default = require("../Psa.Printer.Default");
var Data_Posix_Signal = require("../Data.Posix.Signal");
var Psa_Types = require("../Psa.Types");
var Psa_Output = require("../Psa.Output");
var usage = "psa - Error/Warning reporting frontend for psc \n\nUsage: psa [--censor-lib] [--censor-src]\n           [--censor-codes=CODES] [--filter-codes=CODES]\n           [--no-colors] [--no-source]\n           [--is-lib=DIR] [--psc=PSC] [--stash]\n           PSC_OPTIONS\n\nAvailable options:\n  -v,--version           Show the version number\n  -h,--help              Show this help text\n  --verbose-stats        Show counts for each warning type\n  --censor-warnings      Censor all warnings\n  --censor-lib           Censor warnings from library sources\n  --censor-src           Censor warnings from project sources\n  --censor-codes=CODES   Censor specific error codes\n  --filter-codes=CODES   Only show specific error codes\n  --no-colors            Disable ANSI colors\n  --no-source            Disable original source code printing\n  --strict               Promotes src warnings to errors\n  --stash                Enable persistent warnings (defaults to .psa-stash)\n  --stash=FILE           Enable persistent warnings using a specific stash file\n  --is-lib=DIR           Distinguishing library path (defaults to 'bower_components')\n  --psc=PSC              Name of psc executable (defaults to 'psc')\n\n  CODES                  Comma-separated list of psc error codes\n  PSC_OPTIONS            Any extra options are passed to psc\n";
var parseOptions = function (opts) {
    return function (args) {
        var isPrefix = function (s) {
            return function (str) {
                var $23 = Data_String.indexOf(s)(str);
                if ($23 instanceof Data_Maybe.Just && $23.value0 === 0) {
                    return true;
                };
                return false;
            };
        };
        var parse = function (p) {
            return function (arg) {
                if (arg === "--version" || arg === "-v") {
                    return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console_1.log($foreign.version))(Node_Process_1.exit(0));
                };
                if (arg === "--help" || arg === "-h") {
                    return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console_1.log(usage))(Node_Process_1.exit(0));
                };
                if (arg === "--stash") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $27 = {};
                        for (var $28 in p) {
                            if (p.hasOwnProperty($28)) {
                                $27[$28] = p[$28];
                            };
                        };
                        $27.stash = true;
                        return $27;
                    })());
                };
                if (arg === "--json-errors") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $29 = {};
                        for (var $30 in p) {
                            if (p.hasOwnProperty($30)) {
                                $29[$30] = p[$30];
                            };
                        };
                        $29.jsonErrors = true;
                        return $29;
                    })());
                };
                if (arg === "--no-source") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $31 = {};
                        for (var $32 in p) {
                            if (p.hasOwnProperty($32)) {
                                $31[$32] = p[$32];
                            };
                        };
                        $31.showSource = false;
                        return $31;
                    })());
                };
                if (arg === "--no-colors" || arg === "--monochrome") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $35 = {};
                        for (var $36 in p) {
                            if (p.hasOwnProperty($36)) {
                                $35[$36] = p[$36];
                            };
                        };
                        $35.opts = (function () {
                            var $33 = {};
                            for (var $34 in p.opts) {
                                if (p.opts.hasOwnProperty($34)) {
                                    $33[$34] = p.opts[$34];
                                };
                            };
                            $33.ansi = false;
                            return $33;
                        })();
                        return $35;
                    })());
                };
                if (arg === "--verbose-stats") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $39 = {};
                        for (var $40 in p) {
                            if (p.hasOwnProperty($40)) {
                                $39[$40] = p[$40];
                            };
                        };
                        $39.opts = (function () {
                            var $37 = {};
                            for (var $38 in p.opts) {
                                if (p.opts.hasOwnProperty($38)) {
                                    $37[$38] = p.opts[$38];
                                };
                            };
                            $37.verboseStats = true;
                            return $37;
                        })();
                        return $39;
                    })());
                };
                if (arg === "--strict") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $43 = {};
                        for (var $44 in p) {
                            if (p.hasOwnProperty($44)) {
                                $43[$44] = p[$44];
                            };
                        };
                        $43.opts = (function () {
                            var $41 = {};
                            for (var $42 in p.opts) {
                                if (p.opts.hasOwnProperty($42)) {
                                    $41[$42] = p.opts[$42];
                                };
                            };
                            $41.strict = true;
                            return $41;
                        })();
                        return $43;
                    })());
                };
                if (arg === "--censor-warnings") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $47 = {};
                        for (var $48 in p) {
                            if (p.hasOwnProperty($48)) {
                                $47[$48] = p[$48];
                            };
                        };
                        $47.opts = (function () {
                            var $45 = {};
                            for (var $46 in p.opts) {
                                if (p.opts.hasOwnProperty($46)) {
                                    $45[$46] = p.opts[$46];
                                };
                            };
                            $45.censorWarnings = true;
                            return $45;
                        })();
                        return $47;
                    })());
                };
                if (arg === "--censor-lib") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $51 = {};
                        for (var $52 in p) {
                            if (p.hasOwnProperty($52)) {
                                $51[$52] = p[$52];
                            };
                        };
                        $51.opts = (function () {
                            var $49 = {};
                            for (var $50 in p.opts) {
                                if (p.opts.hasOwnProperty($50)) {
                                    $49[$50] = p.opts[$50];
                                };
                            };
                            $49.censorLib = true;
                            return $49;
                        })();
                        return $51;
                    })());
                };
                if (arg === "--censor-lib") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $55 = {};
                        for (var $56 in p) {
                            if (p.hasOwnProperty($56)) {
                                $55[$56] = p[$56];
                            };
                        };
                        $55.opts = (function () {
                            var $53 = {};
                            for (var $54 in p.opts) {
                                if (p.opts.hasOwnProperty($54)) {
                                    $53[$54] = p.opts[$54];
                                };
                            };
                            $53.censorLib = true;
                            return $53;
                        })();
                        return $55;
                    })());
                };
                if (arg === "--censor-src") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $59 = {};
                        for (var $60 in p) {
                            if (p.hasOwnProperty($60)) {
                                $59[$60] = p[$60];
                            };
                        };
                        $59.opts = (function () {
                            var $57 = {};
                            for (var $58 in p.opts) {
                                if (p.opts.hasOwnProperty($58)) {
                                    $57[$58] = p.opts[$58];
                                };
                            };
                            $57.censorSrc = true;
                            return $57;
                        })();
                        return $59;
                    })());
                };
                if (isPrefix("--censor-codes=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $63 = {};
                        for (var $64 in p) {
                            if (p.hasOwnProperty($64)) {
                                $63[$64] = p[$64];
                            };
                        };
                        $63.opts = (function () {
                            var $61 = {};
                            for (var $62 in p.opts) {
                                if (p.opts.hasOwnProperty($62)) {
                                    $61[$62] = p.opts[$62];
                                };
                            };
                            $61.censorCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.censorCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $61;
                        })();
                        return $63;
                    })());
                };
                if (isPrefix("--filter-codes=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $67 = {};
                        for (var $68 in p) {
                            if (p.hasOwnProperty($68)) {
                                $67[$68] = p[$68];
                            };
                        };
                        $67.opts = (function () {
                            var $65 = {};
                            for (var $66 in p.opts) {
                                if (p.opts.hasOwnProperty($66)) {
                                    $65[$66] = p.opts[$66];
                                };
                            };
                            $65.filterCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.filterCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $65;
                        })();
                        return $67;
                    })());
                };
                if (isPrefix("--is-lib=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $71 = {};
                        for (var $72 in p) {
                            if (p.hasOwnProperty($72)) {
                                $71[$72] = p[$72];
                            };
                        };
                        $71.opts = (function () {
                            var $69 = {};
                            for (var $70 in p.opts) {
                                if (p.opts.hasOwnProperty($70)) {
                                    $69[$70] = p.opts[$70];
                                };
                            };
                            $69.libDirs = Data_Array.snoc(p.opts.libDirs)(Data_String.drop(9)(arg));
                            return $69;
                        })();
                        return $71;
                    })());
                };
                if (isPrefix("--psc=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $73 = {};
                        for (var $74 in p) {
                            if (p.hasOwnProperty($74)) {
                                $73[$74] = p[$74];
                            };
                        };
                        $73.psc = Data_String.drop(6)(arg);
                        return $73;
                    })());
                };
                if (isPrefix("--stash=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $75 = {};
                        for (var $76 in p) {
                            if (p.hasOwnProperty($76)) {
                                $75[$76] = p[$76];
                            };
                        };
                        $75.stash = true;
                        $75.stashFile = Data_String.drop(8)(arg);
                        return $75;
                    })());
                };
                if (Prelude.otherwise) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $77 = {};
                        for (var $78 in p) {
                            if (p.hasOwnProperty($78)) {
                                $77[$78] = p[$78];
                            };
                        };
                        $77.extra = Data_Array.snoc(p.extra)(arg);
                        return $77;
                    })());
                };
                throw new Error("Failed pattern match at Main line 104, column 1 - line 181, column 1: " + [ p.constructor.name, arg.constructor.name ]);
            };
        };
        var defaultLibDir = function (x) {
            if (Data_Array.length(x.opts.libDirs) === 0) {
                var $82 = {};
                for (var $83 in x) {
                    if (x.hasOwnProperty($83)) {
                        $82[$83] = x[$83];
                    };
                };
                $82.opts = (function () {
                    var $80 = {};
                    for (var $81 in x.opts) {
                        if (x.opts.hasOwnProperty($81)) {
                            $80[$81] = x.opts[$81];
                        };
                    };
                    $80.libDirs = [ "bower_components" ];
                    return $80;
                })();
                return $82;
            };
            if (Prelude.otherwise) {
                return x;
            };
            throw new Error("Failed pattern match at Main line 104, column 1 - line 181, column 1: " + [ x.constructor.name ]);
        };
        return Prelude["<$>"](Control_Monad_Eff.functorEff)(defaultLibDir)(Data_Array.foldM(Control_Monad_Eff.monadEff)(parse)({
            extra: [  ], 
            psc: "psc", 
            showSource: true, 
            stash: false, 
            stashFile: ".psa-stash", 
            jsonErrors: false, 
            opts: opts
        })(args));
    };
};
var defaultOptions = {
    ansi: true, 
    censorWarnings: false, 
    censorLib: false, 
    censorSrc: false, 
    censorCodes: Data_Set.empty, 
    filterCodes: Data_Set.empty, 
    verboseStats: false, 
    libDirs: [  ], 
    strict: false, 
    cwd: ""
};

/**
 *  Due to `catchException` label annoyingness
 */
var catchException$prime = function (eb) {
    return function (eff) {
        return Unsafe_Coerce.unsafeCoerce(Control_Monad_Eff_Exception.catchException(Unsafe_Coerce.unsafeCoerce(eb))(Unsafe_Coerce.unsafeCoerce(eff)));
    };
};
var main = (function () {
    
    /**
     *  TODO: Handle exceptions
     */
    var stdio = [ new Data_Maybe.Just(Node_ChildProcess_1.Pipe.value), Node_ChildProcess_1.inherit[1], new Data_Maybe.Just(Node_ChildProcess_1.Pipe.value) ];
    var spawn$prime = function (cmd) {
        return function (args) {
            return function (onExit) {
                return function __do() {
                    var v = Node_ChildProcess_1.spawn(cmd)(args)((function () {
                        var $84 = {};
                        for (var $85 in Node_ChildProcess_1.defaultSpawnOptions) {
                            if (Node_ChildProcess_1.defaultSpawnOptions.hasOwnProperty($85)) {
                                $84[$85] = Node_ChildProcess_1.defaultSpawnOptions[$85];
                            };
                        };
                        $84.stdio = stdio;
                        return $84;
                    })())();
                    var v1 = Control_Monad_ST_1.newSTRef("")();
                    Node_Stream.onDataString(Node_ChildProcess_1.stderr(v))(Node_Encoding.UTF8.value)(function (chunk) {
                        return Prelude["void"](Control_Monad_Eff.functorEff)(Control_Monad_ST_1.modifySTRef(v1)(function (v2) {
                            return v2 + chunk;
                        }));
                    })();
                    Node_ChildProcess_1.onExit(v)(function (status) {
                        if (status instanceof Node_ChildProcess_1.Normally) {
                            return function __do() {
                                Prelude[">>="](Control_Monad_Eff.bindEff)(Control_Monad_ST_1.readSTRef(v1))(onExit)();
                                return Node_Process_1.exit(status.value0)();
                            };
                        };
                        if (status instanceof Node_ChildProcess_1.BySignal) {
                            return function __do() {
                                Control_Monad_Eff_Console_1.error(Prelude.show(Data_Posix_Signal.showSignal)(status.value0))();
                                return Node_Process_1.exit(1)();
                            };
                        };
                        throw new Error("Failed pattern match at Main line 245, column 7 - line 252, column 5: " + [ status.constructor.name ]);
                    })();
                    return Node_ChildProcess_1.onError(v)(retryWithCmd(cmd)(args)(onExit))();
                };
            };
        };
    };
    var retryWithCmd = function (cmd) {
        return function (args) {
            return function (onExit) {
                return function (err) {
                    if (err.code === "ENOENT") {
                        var $95 = Prelude["=="](Node_Platform.eqPlatform)(Node_Process_1.platform)(Node_Platform.Win32.value);
                        if ($95) {
                            var $96 = Data_String.stripSuffix(".cmd")(cmd);
                            if ($96 instanceof Data_Maybe.Nothing) {
                                return spawn$prime(cmd + ".cmd")(args)(onExit);
                            };
                            if ($96 instanceof Data_Maybe.Just) {
                                return Control_Monad_Eff_Exception["throw"]("`" + ($96.value0 + ("` executable not found. (nor `" + (cmd + "`)"))));
                            };
                            throw new Error("Failed pattern match at Main line 259, column 10 - line 262, column 8: " + [ $96.constructor.name ]);
                        };
                        if (!$95) {
                            return Control_Monad_Eff_Exception["throw"]("`" + (cmd + "` executable not found."));
                        };
                        throw new Error("Failed pattern match at Main line 257, column 6 - line 264, column 5: " + [ $95.constructor.name ]);
                    };
                    if (Prelude.otherwise) {
                        return Control_Monad_Eff_Exception.throwException(Node_ChildProcess_1.toStandardError(err));
                    };
                    throw new Error("Failed pattern match at Main line 194, column 1 - line 314, column 1: " + [ cmd.constructor.name, args.constructor.name, onExit.constructor.name, err.constructor.name ]);
                };
            };
        };
    };
    var mergeWarnings = function (filenames) {
        return function (date) {
            return function (old) {
                return function ($$new) {
                    return function __do() {
                        var v = Data_StrMap_ST["new"]();
                        var v1 = Prelude.flip(Data_Array.filterM(Control_Monad_Eff.monadEff))(old)(function (x) {
                            if (x.filename instanceof Data_Maybe.Nothing) {
                                return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                            };
                            if (x.filename instanceof Data_Maybe.Just) {
                                var $100 = Data_Set.member(Prelude.ordString)(x.filename.value0)(filenames);
                                if ($100) {
                                    return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                                };
                                if (!$100) {
                                    return function __do() {
                                        var v1 = Data_StrMap_ST.peek(v)(x.filename.value0)();
                                        if (v1 instanceof Data_Maybe.Just) {
                                            return v1.value0;
                                        };
                                        if (v1 instanceof Data_Maybe.Nothing) {
                                            var v2 = catchException$prime(function (v2) {
                                                return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                                            })(Prelude["<$>"](Control_Monad_Eff.functorEff)(function ($144) {
                                                return Prelude[">"](Data_Date.ordDate)(date)(Node_FS_Stats.modifiedTime($144));
                                            })(Node_FS_Sync.stat(x.filename.value0)))();
                                            Data_StrMap_ST.poke(v)(x.filename.value0)(v2)();
                                            return v2;
                                        };
                                        throw new Error("Failed pattern match at Main line 304, column 15 - line 311, column 5: " + [ v1.constructor.name ]);
                                    };
                                };
                                throw new Error("Failed pattern match at Main line 300, column 11 - line 311, column 5: " + [ $100.constructor.name ]);
                            };
                            throw new Error("Failed pattern match at Main line 297, column 7 - line 311, column 5: " + [ x.filename.constructor.name ]);
                        })();
                        return Prelude["<>"](Prelude.semigroupArray)(v1)($$new);
                    };
                };
            };
        };
    };
    var loadNothing = function (v) {
        return function (v1) {
            return Prelude.pure(Control_Monad_Eff.applicativeEff)(Data_Maybe.Nothing.value);
        };
    };
    var loadLines = function (files) {
        return function (filename) {
            return function (pos) {
                return function __do() {
                    var v = (function __do() {
                        var cache = Data_StrMap_ST.peek(files)(filename)();
                        if (cache instanceof Data_Maybe.Just) {
                            return cache.value0;
                        };
                        if (cache instanceof Data_Maybe.Nothing) {
                            var v = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(filename))();
                            Data_StrMap_ST.poke(files)(filename)(v)();
                            return v;
                        };
                        throw new Error("Failed pattern match at Main line 270, column 7 - line 276, column 5: " + [ cache.constructor.name ]);
                    })();
                    var source = Data_Array.slice(pos.startLine - 1)(pos.endLine)(v);
                    return new Data_Maybe.Just(source);
                };
            };
        };
    };
    var insertFilenames = Data_Foldable.foldr(Data_Foldable.foldableArray)(function (x) {
        return function (s) {
            return Data_Maybe.maybe(s)(Prelude.flip(Data_Set.insert(Prelude.ordString))(s))(x.filename);
        };
    });
    var encodeStash = function (s) {
        return Data_Argonaut_Encode.encodeJson(Data_Argonaut_Encode.encodeJsonArray(Data_Argonaut_Encode.encodeJsonJson))(Prelude["<$>"](Prelude.functorArray)(Psa_Types.encodePsaError)(s));
    };
    var writeStashFile = function (stashFile) {
        return function (warnings) {
            var file = Data_Argonaut_Printer.printJson(Data_Argonaut_Printer.printerString)(encodeStash(warnings));
            return Node_FS_Sync.writeTextFile(Node_Encoding.UTF8.value)(stashFile)(file);
        };
    };
    var emptyStash = Prelude["<$>"](Control_Monad_Eff.functorEff)(function (v) {
        return {
            date: v, 
            stash: [  ]
        };
    })(Data_Date.now);
    var decodeStash = function (s) {
        return Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(s))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeArray(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson)))))(Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Either.applicativeEither)(Psa_Types.parsePsaError));
    };
    var readStashFile = function (stashFile) {
        return catchException$prime(Prelude["const"](emptyStash))(function __do() {
            var v = Node_FS_Sync.stat(stashFile)();
            var v1 = Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(stashFile)();
            var $114 = decodeStash(v1);
            if ($114 instanceof Data_Either.Left) {
                return emptyStash();
            };
            if ($114 instanceof Data_Either.Right) {
                return {
                    date: Node_FS_Stats.modifiedTime(v), 
                    stash: $114.value0
                };
            };
            throw new Error("Failed pattern match at Main line 286, column 5 - line 290, column 3: " + [ $114.constructor.name ]);
        });
    };
    return Prelude["void"](Control_Monad_Eff.functorEff)(function __do() {
        var v = Node_Process_1.cwd();
        var v1 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Array.drop(2))(Node_Process_1.argv)();
        var v2 = parseOptions((function () {
            var $119 = {};
            for (var $120 in defaultOptions) {
                if (defaultOptions.hasOwnProperty($120)) {
                    $119[$120] = defaultOptions[$120];
                };
            };
            $119.cwd = v;
            return $119;
        })())(v1)();
        var opts$prime = (function () {
            var $122 = {};
            for (var $123 in v2.opts) {
                if (v2.opts.hasOwnProperty($123)) {
                    $122[$123] = v2.opts[$123];
                };
            };
            $122.libDirs = Prelude["<$>"](Prelude.functorArray)(function ($145) {
                return (function (v3) {
                    return v3 + Node_Path.sep;
                })(Node_Path.resolve([ v ])($145));
            })(v2.opts.libDirs);
            return $122;
        })();
        var args = Data_Array.cons("--json-errors")(v2.extra);
        var v3 = (function () {
            if (v2.stash) {
                return readStashFile(v2.stashFile);
            };
            if (!v2.stash) {
                return emptyStash;
            };
            throw new Error("Failed pattern match at Main line 211, column 5 - line 215, column 3: " + [ v2.stash.constructor.name ]);
        })()();
        return spawn$prime(v2.psc)(args)(function (buffer) {
            var stderr = Data_String.split("\n")(buffer);
            return Data_Foldable.for_(Control_Monad_Eff.applicativeEff)(Data_Foldable.foldableArray)(stderr)(function (err) {
                var $126 = Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(err))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson))))(Psa_Types.parsePsaResult);
                if ($126 instanceof Data_Either.Left) {
                    return Control_Monad_Eff_Console_1.error(err);
                };
                if ($126 instanceof Data_Either.Right) {
                    return function __do() {
                        var v4 = Data_StrMap_ST["new"]();
                        var loadLinesImpl = (function () {
                            if (v2.showSource) {
                                return loadLines(v4);
                            };
                            if (!v2.showSource) {
                                return loadNothing;
                            };
                            throw new Error("Failed pattern match at Main line 222, column 31 - line 223, column 15: " + [ v2.showSource.constructor.name ]);
                        })();
                        var filenames = insertFilenames(insertFilenames(Data_Set.empty)($126.value0.errors))($126.value0.warnings);
                        var v5 = mergeWarnings(filenames)(v3.date)(v3.stash)($126.value0.warnings)();
                        Control_Monad.when(Control_Monad_Eff.monadEff)(v2.stash)(writeStashFile(v2.stashFile)(v5))();
                        var v6 = Psa_Output.output(Control_Monad_Eff.monadEff)(loadLinesImpl)(opts$prime)((function () {
                            var $131 = {};
                            for (var $132 in $126.value0) {
                                if ($126.value0.hasOwnProperty($132)) {
                                    $131[$132] = $126.value0[$132];
                                };
                            };
                            $131.warnings = v5;
                            return $131;
                        })())();
                        (function () {
                            if (v2.jsonErrors) {
                                return Control_Monad_Eff_Console_1.error(err);
                            };
                            if (!v2.jsonErrors) {
                                return Psa_Printer_Default.print(opts$prime)(v6);
                            };
                            throw new Error("Failed pattern match at Main line 227, column 11 - line 230, column 11: " + [ v2.jsonErrors.constructor.name ]);
                        })()();
                        var $135 = Data_StrMap.isEmpty(v6.stats.allErrors);
                        if ($135) {
                            return Node_Process_1.exit(0)();
                        };
                        if (!$135) {
                            return Node_Process_1.exit(1)();
                        };
                        throw new Error("Failed pattern match at Main line 230, column 11 - line 234, column 3: " + [ $135.constructor.name ]);
                    };
                };
                throw new Error("Failed pattern match at Main line 218, column 7 - line 234, column 3: " + [ $126.constructor.name ]);
            });
        })();
    });
})();
module.exports = {
    "catchException'": catchException$prime, 
    main: main, 
    parseOptions: parseOptions, 
    defaultOptions: defaultOptions, 
    usage: usage, 
    version: $foreign.version
};
