// Generated by psc version 0.8.2.0
"use strict";
var Prelude = require("../Prelude");
var Data_Maybe = require("../Data.Maybe");
var Data_Function = require("../Data.Function");
var Data_Nullable = require("../Data.Nullable");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Node_Stream = require("../Node.Stream");
var Node_Path = require("../Node.Path");
var Node_FS = require("../Node.FS");
var Node_FS_Perms_1 = require("../Node.FS.Perms");
var Node_FS_Perms_1 = require("../Node.FS.Perms");
var Node_FS_Internal = require("../Node.FS.Internal");
var readWrite = (function () {
    var rw = Prelude["+"](Node_FS_Perms_1.semiringPerm)(Node_FS_Perms_1.read)(Node_FS_Perms_1.write);
    return Node_FS_Perms_1.mkPerms(rw)(rw)(rw);
})();
var $$null = Data_Nullable.toNullable(Data_Maybe.Nothing.value);
var nonnull = function ($8) {
    return Data_Nullable.toNullable(Data_Maybe.Just.create($8));
};
var fs = Node_FS_Internal.unsafeRequireFS;

/**
 *  | Like `fdCreateWriteStream`, but allows you to pass options.
 */
var fdCreateWriteStreamWith = function (opts) {
    return function (fd) {
        return Node_FS_Internal.mkEff(function (v) {
            return fs.createWriteStream($$null, {
                fd: fd, 
                mode: Node_FS_Perms_1.permsToInt(opts.perms), 
                flags: Node_FS.fileFlagsToNode(opts.flags)
            });
        });
    };
};

/**
 *  | Create a Readable stream which reads data from the specified file descriptor.
 */
var fdCreateReadStreamWith = function (opts) {
    return function (fd) {
        return Node_FS_Internal.mkEff(function (v) {
            return fs.createReadStream($$null, {
                fd: fd, 
                mode: Node_FS_Perms_1.permsToInt(opts.perms), 
                flags: Node_FS.fileFlagsToNode(opts.flags), 
                autoClose: opts.autoClose
            });
        });
    };
};
var defaultWriteStreamOptions = {
    flags: Node_FS.W.value, 
    perms: readWrite
};

/**
 *  | Create a Writable stream which writes data to the specified file
 *  | descriptor, using the default options.
 */
var fdCreateWriteStream = fdCreateWriteStreamWith(defaultWriteStreamOptions);
var defaultReadStreamOptions = {
    flags: Node_FS.R.value, 
    perms: readWrite, 
    autoClose: true
};

/**
 *  | Create a Readable stream which reads data to the specified file
 *  | descriptor, using the default options.
 */
var fdCreateReadStream = fdCreateReadStreamWith(defaultReadStreamOptions);

/**
 *  | Like `createWriteStream`, but allows you to pass options.
 */
var createWriteStreamWith = function (opts) {
    return function (file) {
        return Node_FS_Internal.mkEff(function (v) {
            return fs.createWriteStream(nonnull(file), {
                mode: Node_FS_Perms_1.permsToInt(opts.perms), 
                flags: Node_FS.fileFlagsToNode(opts.flags)
            });
        });
    };
};

/**
 *  | Create a Writable stream which writes data to the specified file, using
 *  | the default options.
 */
var createWriteStream = createWriteStreamWith(defaultWriteStreamOptions);

/**
 *  | Create a Readable stream which reads data from the specified file.
 */
var createReadStreamWith = function (opts) {
    return function (file) {
        return Node_FS_Internal.mkEff(function (v) {
            return fs.createReadStream(nonnull(file), {
                mode: Node_FS_Perms_1.permsToInt(opts.perms), 
                flags: Node_FS.fileFlagsToNode(opts.flags), 
                autoClose: opts.autoClose
            });
        });
    };
};

/**
 *  | Create a Readable stream which reads data to the specified file, using
 *  | the default options.
 */
var createReadStream = createReadStreamWith(defaultReadStreamOptions);
module.exports = {
    fdCreateReadStreamWith: fdCreateReadStreamWith, 
    createReadStreamWith: createReadStreamWith, 
    defaultReadStreamOptions: defaultReadStreamOptions, 
    fdCreateReadStream: fdCreateReadStream, 
    createReadStream: createReadStream, 
    fdCreateWriteStreamWith: fdCreateWriteStreamWith, 
    createWriteStreamWith: createWriteStreamWith, 
    defaultWriteStreamOptions: defaultWriteStreamOptions, 
    fdCreateWriteStream: fdCreateWriteStream, 
    createWriteStream: createWriteStream
};
