// Generated by psc version 0.8.2.0
"use strict";
var Prelude = require("../Prelude");
var Data_Array = require("../Data.Array");
var Data_Foldable = require("../Data.Foldable");
var Data_Maybe = require("../Data.Maybe");
var Data_Monoid = require("../Data.Monoid");
var Data_String = require("../Data.String");
var Data_StrMap = require("../Data.StrMap");
var Data_Tuple = require("../Data.Tuple");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console = require("../Control.Monad.Eff.Console");
var Ansi_Output = require("../Ansi.Output");
var Ansi_Codes = require("../Ansi.Codes");
var Psa_Types = require("../Psa.Types");
var Psa_Output = require("../Psa.Output");
var Psa_Printer = require("../Psa.Printer");
var Psa_Util = require("../Psa.Util");
var toLines = function ($32) {
    return Psa_Printer.para(Prelude.map(Prelude.functorArray)(function ($33) {
        return Psa_Printer.line(Data_Array.singleton(Psa_Printer.plain($33)));
    })(Data_String.split("\n")($32)));
};
var renderStatus = function (gfx) {
    return function (total) {
        return function (index) {
            return function (code) {
                return Psa_Printer.style(gfx)("[" + (Prelude.show(Prelude.showInt)(index) + ("/" + (Prelude.show(Prelude.showInt)(total) + (" " + (code + "]"))))));
            };
        };
    };
};
var renderStatCols = function (col1) {
    return function (col2) {
        return function (col3) {
            return function (col4) {
                var lineLength = function ($34) {
                    return Data_Foldable.sum(Data_Foldable.foldableArray)(Prelude.semiringInt)(Prelude.map(Prelude.functorArray)(Psa_Printer.ansiLength)($34));
                };
                var gutter = [ Psa_Printer.plain("   ") ];
                var catRow = function (c1) {
                    return function (c2) {
                        return function (c3) {
                            return function (c4) {
                                return Psa_Printer.line(Prelude["<>"](Prelude.semigroupArray)(c1)(Prelude["<>"](Prelude.semigroupArray)(gutter)(Prelude["<>"](Prelude.semigroupArray)(c2)(Prelude["<>"](Prelude.semigroupArray)(gutter)(Prelude["<>"](Prelude.semigroupArray)(c3)(Prelude["<>"](Prelude.semigroupArray)(gutter)(c4)))))));
                            };
                        };
                    };
                };
                var align = function (f) {
                    return function (ls) {
                        var max = Data_Maybe.fromMaybe(0)(Data_Foldable.maximum(Prelude.ordInt)(Data_Foldable.foldableArray)(Prelude.map(Prelude.functorArray)(lineLength)(ls)));
                        var pad = function (l) {
                            return f(Psa_Printer.plain(Psa_Util.replicate(Data_Monoid.monoidString)(max - lineLength(l))(" ")))(l);
                        };
                        return Prelude.map(Prelude.functorArray)(pad)(ls);
                    };
                };
                var alignLeft = align(function (a) {
                    return function (as) {
                        return Data_Array.snoc(as)(a);
                    };
                });
                var alignRight = align(function (a) {
                    return function (as) {
                        return Data_Array.cons(a)(as);
                    };
                });
                return Psa_Printer.para(Data_Array.zipWith(Prelude["$"])(Data_Array.zipWith(Prelude["$"])(Data_Array.zipWith(Prelude["$"])(Prelude.map(Prelude.functorArray)(catRow)(alignLeft(Prelude["<>"](Prelude.semigroupArray)([ [ Psa_Printer.plain("") ] ])(col1))))(alignLeft(Prelude["<>"](Prelude.semigroupArray)([ [ Psa_Printer.plain("Src") ] ])(col2))))(alignLeft(Prelude["<>"](Prelude.semigroupArray)([ [ Psa_Printer.plain("Lib") ] ])(col3))))(alignLeft(Prelude["<>"](Prelude.semigroupArray)([ [ Psa_Printer.plain("All") ] ])(col4))));
            };
        };
    };
};
var renderStat = function (v) {
    if (v.value0 === 0 && v.value1 === 0) {
        return [ Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Green.value))("0") ];
    };
    if (v.value0 === v.value1) {
        return [ Psa_Printer.plain(Prelude.show(Prelude.showInt)(v.value0)) ];
    };
    return [ Psa_Printer.plain(Prelude.show(Prelude.showInt)(v.value0)), Psa_Printer.style(Ansi_Output.dim)("/" + Prelude.show(Prelude.showInt)(v.value1)) ];
};
var renderStats = function (stats) {
    var sumRatio = function (v) {
        return function (v1) {
            return function (v2) {
                return new Data_Tuple.Tuple(v.value0 + v2.value0 | 0, v.value1 + v2.value1 | 0);
            };
        };
    };
    var srcWarnings = Data_StrMap.fold(sumRatio)(new Data_Tuple.Tuple(0, 0))(stats.srcWarnings);
    var srcErrors = Data_StrMap.fold(sumRatio)(new Data_Tuple.Tuple(0, 0))(stats.srcErrors);
    var libWarnings = Data_StrMap.fold(sumRatio)(new Data_Tuple.Tuple(0, 0))(stats.libWarnings);
    var libErrors = Data_StrMap.fold(sumRatio)(new Data_Tuple.Tuple(0, 0))(stats.libErrors);
    var allWarnings = Data_StrMap.fold(sumRatio)(new Data_Tuple.Tuple(0, 0))(stats.allWarnings);
    var allErrors = Data_StrMap.fold(sumRatio)(new Data_Tuple.Tuple(0, 0))(stats.allErrors);
    return renderStatCols([ [ Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Yellow.value))("Warnings") ], [ Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Red.value))("Errors") ] ])([ renderStat(srcWarnings), renderStat(srcErrors) ])([ renderStat(libWarnings), renderStat(libErrors) ])([ renderStat(allWarnings), renderStat(allErrors) ]);
};
var renderVerboseStats = function (stats) {
    var warnings = Data_Array.sort(Prelude.ordString)(Data_StrMap.keys(stats.allWarnings));
    var warningLabels = Prelude["<$>"](Prelude.functorArray)(function ($35) {
        return Data_Array.singleton(Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Yellow.value))($35));
    })(warnings);
    var getStat = function (key) {
        return function (x) {
            return Data_Maybe.fromMaybe(new Data_Tuple.Tuple(0, 0))(Data_StrMap.lookup(key)(x));
        };
    };
    var getStats = function (ks) {
        return function (x) {
            return Prelude["<$>"](Prelude.functorArray)(function (k) {
                return renderStat(getStat(k)(x));
            })(ks);
        };
    };
    var libWarnings = getStats(warnings)(stats.libWarnings);
    var srcWarnings = getStats(warnings)(stats.srcWarnings);
    var errors = Data_Array.sort(Prelude.ordString)(Data_StrMap.keys(stats.allErrors));
    var libErrors = getStats(errors)(stats.libErrors);
    var srcErrors = getStats(errors)(stats.srcErrors);
    var errorLabels = Prelude["<$>"](Prelude.functorArray)(function ($36) {
        return Data_Array.singleton(Psa_Printer.style(Ansi_Output.foreground(Ansi_Codes.Red.value))($36));
    })(errors);
    var allWarnings = getStats(warnings)(stats.allWarnings);
    var allErrors = getStats(errors)(stats.allErrors);
    return renderStatCols(Prelude["<>"](Prelude.semigroupArray)(warningLabels)(errorLabels))(Prelude["<>"](Prelude.semigroupArray)(srcWarnings)(srcErrors))(Prelude["<>"](Prelude.semigroupArray)(libWarnings)(libErrors))(Prelude["<>"](Prelude.semigroupArray)(allWarnings)(allErrors));
};
var renderPosition = function (pos) {
    return [ Psa_Printer.style(Ansi_Output.dim)(":"), Psa_Printer.plain(Prelude.show(Prelude.showInt)(pos.startLine)), Psa_Printer.style(Ansi_Output.dim)(":"), Psa_Printer.plain(Prelude.show(Prelude.showInt)(pos.startColumn)) ];
};
var renderPath = function (v) {
    if (v instanceof Psa_Types.Src) {
        return Psa_Printer.plain(v.value0);
    };
    if (v instanceof Psa_Types.Lib) {
        return Psa_Printer.plain(v.value0);
    };
    return Psa_Printer.plain("");
};
var indented = Psa_Printer.indent([ Psa_Printer.plain("  ") ]);
var emptyLine = Psa_Printer.line([ Psa_Printer.plain("") ]);
var renderSource$prime = function (pos) {
    return function (lines) {
        return Prelude["<>"](Psa_Printer.semigroupRow)(Psa_Printer.renderSource(pos)(lines))(emptyLine);
    };
};
var render = function (gfx) {
    return function (total) {
        return function (index) {
            return function (v) {
                return Psa_Printer.para([ Psa_Printer.line(Prelude["<>"](Prelude.semigroupArray)([ renderStatus(gfx)(total)(index)(v.error.errorCode), Psa_Printer.plain(" "), renderPath(v.path) ])(Data_Maybe.fromMaybe(Data_Monoid.mempty(Data_Monoid.monoidArray))(Prelude["<$>"](Data_Maybe.functorMaybe)(renderPosition)(v.position)))), emptyLine, indented(Prelude["<>"](Psa_Printer.semigroupRow)(Data_Maybe.fromMaybe(Data_Monoid.mempty(Psa_Printer.monoidRow))(Prelude["<*>"](Data_Maybe.applyMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(renderSource$prime)(v.position))(v.source)))(toLines(v.error.message))) ]);
            };
        };
    };
};
var renderError = render(Ansi_Output.foreground(Ansi_Codes.Red.value));
var renderWarning = render(Ansi_Output.foreground(Ansi_Codes.Yellow.value));

/**
 *  | Prints output to the console.
 */
var print = function (options) {
    return function (output) {
        var toString = Psa_Printer.renderRow(function ($37) {
            return Data_String.joinWith("")(Prelude.map(Prelude.functorArray)(Psa_Printer.renderAnsi(options.ansi))($37));
        });
        var renderStats$prime = (function () {
            if (options.verboseStats) {
                return renderVerboseStats;
            };
            if (!options.verboseStats) {
                return renderStats;
            };
            throw new Error("Failed pattern match at Psa.Printer.Default line 43, column 18 - line 45, column 1: " + [ options.verboseStats.constructor.name ]);
        })();
        var lenWarnings = Data_Array.length(output.warnings);
        var lenErrors = Data_Array.length(output.errors);
        return function __do() {
            Psa_Util.iter_(Data_Foldable.foldableArray)(Control_Monad_Eff.applicativeEff)(output.warnings)(function (i) {
                return function (warning) {
                    return function __do() {
                        Control_Monad_Eff_Console.error(toString(renderWarning(lenWarnings)(i + 1 | 0)(warning)))();
                        return Control_Monad_Eff_Console.error("")();
                    };
                };
            })();
            Psa_Util.iter_(Data_Foldable.foldableArray)(Control_Monad_Eff.applicativeEff)(output.errors)(function (i) {
                return function (error) {
                    return function __do() {
                        Control_Monad_Eff_Console.error(toString(renderError(lenErrors)(i + 1 | 0)(error)))();
                        return Control_Monad_Eff_Console.error("")();
                    };
                };
            })();
            return Control_Monad_Eff_Console.error(toString(renderStats$prime(output.stats)))();
        };
    };
};
module.exports = {
    print: print, 
    renderVerboseStats: renderVerboseStats, 
    renderStats: renderStats, 
    renderError: renderError, 
    renderWarning: renderWarning
};
